﻿#pragma once

#if defined(__APPLE__) || defined(__unix__)
#define VB_IMPORT
#define VB_API_CALL
#else
#define VB_IMPORT __declspec(dllimport)
#define VB_API_CALL __stdcall
#ifdef _WIN64
#pragma comment(lib, "virbox64.lib")
#else
#pragma comment(lib, "virbox32.lib")
#endif // _WIN64
#endif // __APPLE__ || __unix__


#ifdef __cplusplus
extern "C" {
#endif

	VB_IMPORT int VB_API_CALL VBProtectBegin(const char *tag);
	VB_IMPORT int VB_API_CALL VBVirtualizeBegin(const char *tag);
	VB_IMPORT int VB_API_CALL VBMutateBegin(const char *tag);
	VB_IMPORT int VB_API_CALL VBSnippetBegin(const char *tag);
	VB_IMPORT void VB_API_CALL VBProtectEnd(void);
	VB_IMPORT void *VB_API_CALL VBProtectDecrypt(void *dst, const void *src, int size);

	
#ifdef __cplusplus
}
#endif
